partial model Compliant
  "Compliant connection of two translational 1D flanges"
  Flange_a flange_a
    "(left) driving flange (flange axis directed INTO cut plane, e. g. from left to right)";
  Flange_b flange_b
    "(right) driven flange (flange axis directed OUT OF cut plane)";
  Real s_rel "relative distance (= flange_b.s - flange_a.s)";
  Real f "forcee between flanges (positive in direction of flange axis R)";
equation
  s_rel = flange_b.s - flange_a.s;
  flange_b.f = f;
  flange_a.f = -f;
end Compliant;

