model SineForce
  "External force acting on a sliding mass"

  constant Real pi = 3.1416;
  parameter Real p_freqHz = 1;
  Real f "driving force";
  Flange_b flange_b;
equation
  f=sin(2*pi*p_freqHz*time);
  flange_b.f = -f;
end Force;

