package devs
  class DevsPort
  end DevsPort;
  class BaseDEVS
    function poke
      input DevsPort outPort;
      input DevsEvent evt;
    end poke;
    function peek
      input DevsPort inPort;
      output DevsEvent evt;
    end peek;
  end BaseDEVS;
  class AtomicDEVS
    extends BaseDEVS;
  end AtomicDEVS;
  class CoupledDEVS
    extends BaseDEVS;
    function connectport
      input DevsPort sourcePort;
      input DevsPort targetPort;
    end connectport;
    function addSubModel
      input BaseDEVS addModel;
      output BaseDEVS modelAdded;
    end addSubModel;
  end CoupledDEVS;
  class DevsState
  end DevsState;
  class DevsEvent
  end DevsEvent;
  class DevsExperiment
  end DevsExperiment;
  class list
    function append
      input DevsEvent evt;
    end append;
  end list;
  function len
  end len;
end devs;

