f = open('testDeep.mo', 'r')
o = open('tmp.mo', 'w')

import sys
length = int(sys.argv[1])

foundRoot = False
rootcode = []
for line in f:
        if "class RootX" in line:
                rootcode = [line]
                foundRoot = True
        elif "end RootX" in line:
                rootcode.append(line)
                foundRoot = False
        elif foundRoot:
                rootcode.append(line)
        if "end test" not in line:
                o.write(line)

# Extend the code with multiple copies of the Root code
for i in range(length):
        line = "  class Root" + str(i) + "\n"
        rootcode[0] = line
        line = "  end Root" + str(i) + ";\n\n"
        rootcode[-1] = line
        for line in rootcode:
                o.write(line)

o.write("end test;\n")

f.close()
o.close()

f = open('tmp.mo', 'r')
o = open('out.mo', 'w')

counter = 0
foundRoot = False
for line in f:
        if "class RootX" in line:
                foundRoot = True
        elif "end RootX" in line:
                foundRoot = False
        elif foundRoot:
                continue
        elif "RootY" in line:
                begin = line.find("RootY")
                newline = line[:begin] + "Root" + str(length-1) + line[begin+5:]
                o.write(newline)
        elif "DECLS" in line:
                if counter == 0:
                        text = '    Processor ins(name="Processor");\n'
                else:
                        text = "    Root" + str(counter-1) + ' ins(name="root_' + str(counter) + '");\n'
                        if counter == length-1:
                                text += '    Generator gen(name="Generator");\n'
                o.write(text)
        elif "CONNECTS" in line:
                if counter == length-1:
                        text = "    connect(gen.p_out, ins.p_in);\n    connect(ins.p_out, p_out);\n"
                else:
                        text = "    connect(p_in, ins.p_in);\n    connect(ins.p_out, p_out);\n"
                o.write(text)
                counter += 1
        else:
                o.write(line)
