// name:     Lookup1
// keywords: scoping
// status:   correct
// 
// Names are looked up in a partially defined class.
// 


final encapsulated partial class Lookup2
  import A.B.C.*;
  extends A.B.vol(unit="mv");
  parameter Real b := 4.0;
  Real A[2:3, 2:3]=0;
  Force f(a1[2,2].a2[3,3]=0, b=0);
equation
  a+b-c=6*9/n;
  for i in (1+a):(2*8):9, j in [2,3] loop
    a[i]=0;
  end for;
  f1(a,b,c=8*9, d=10, e=80);
  f2(b[i,j].c[k,l] for i in 1:5, j in 1:4);
  f3();
  connect(a[:], a.b);
  connect(a[2,2].b[3,3], a.c[6,6]);
end Lookup1;

// fclass Lookup1
//   constant Real a;
//   Real b.c;
// equation
//   a = 3.0;
//   b.c = a;
// end Lookup1;

