package E
//record E

  type Vol = Real (unit="V");

  type Current = Real(unit="A");

  //encapsulated connector Pin 
  connector Pin
    Vol v;
    flow Current i;
  end Pin;
  
  partial model OnePort
    Vol v;
    Current i;
    Pin p, n;
  equation
    p.v-n.v=v;
    p.i+n.i=0.0;
    i=p.i;
  end OnePort;

  constant Real pi=3.14;

end E;

function Sum
  input Real a;
  output Real b;
end Sum;


class Lookup1
  //E.pi p=3.15;
  //E.OnePort onePort;
  E.Pin p;
  E.Vol v;
  Integer j=6;
  constant Real a(unit="v") = 3.0;
  class B
    Real c;
  equation
    c=v; // this is legal, v refers to E.Vol v
  end B;
  B b;
  Sum sum;
  //type DigitalCurrentChoices = enumeration(zero, one);
  //DigitalCurrentChoices dc;
equation
  //v.start=0.0;
  //dc.quantity="Current";
  //if dc.one > dc.zero then 
    //sum();
  //end if;
  //if b.c.value==a then
    for m in 1:j loop 
      b=sum(n+m for n in 1:m);
    end for;
    (a, b.c)=(10.0, 10.0);
  //end if;
  for i in 1:j, k in 2:j loop
    a=i+j+k;
    a={i,j,k};
  end for;
  //j = if b.c > a then 1.0 else 2.0;
end Lookup1;


// fclass Lookup1
//   constant Real a;
//   Real b.c;
// equation
//   a = 3.0;
//   b.c = a;
// end Lookup1;

