// name:     Lookup2
// keywords: scoping
// status:   correct
// 
// Note that in order to use Lookup2Package.a
// Either Lookup2Package must satisfy the requirements of
// a package 
// or a must be an encapsulated element
// (Modelica 1.4 spec 3.1.1.2)


class Lookup2Package
  constant Real a = 3.0;
  class D
    Real d1, d2;
  equation
    d1=d2;
    //d1=a;
  end D;
  class F
    D d;
  equation
    d.d1 = a;
  end F;
  encapsulated class B
    class BB
      Real bb;
    end BB;
    Real c; 
  end B;
end Lookup2Package;

class C1
  extends Lookup2Package.B;
  class C11
    Real x;
  end C11;
end C1;

class C2 
  extends C1;
end C2;

model Lookup2
  extends C2;
  //extends Lookup2Package.B;
  //extends Lookup2Package.D;
  extends Lookup2Package.F;
  class Lookup21
    extends Lookup2Package.D;
  end Lookup3;
  Lookup2Package.D z;
  C1 c1;
  C11 t;
  BB bb1;
  C1.BB bb2; // should this be legal?
equation
  t.x=100;
  z.d1=1.0;
  d.d1=10+d.d2;
  //f=d2/2;
end Lookup2;

//class Lookup3
  //extends Lookup2;
//end Lookup3;

// fclass Lookup2
//   Real a;
//   Real c.b
// equation
//   a = 3.0;
//   b.c = a;
// end Lookup2;

