import sys
import os.path
sys.path.append(os.path.expanduser('~/DEVSEnv/pydevs/'))

from DEVS import *
from simulator import *
from queue import *

#sim.simulate(termination_condition=terminate_never, 
#             verbose=True)

# B. Simulate until a specified end_time is reached.
#    When the end_time is reached/exceeded, the 
#    termination_condition function returns True.
#
def terminate_whenEndTimeReached(model, clock, end_time=1000):
  if clock >= end_time:
    return True
  else:
    return False


if __name__ == '__main__':
  theExperiment = Root(pqs = 2, pia = 3, pib = 3, psa = 4, psb = 6, name = "theSystem")
  sim = Simulator(theExperiment)
  i = sim.simulate(termination_condition=terminate_whenEndTimeReached, verbose=True, trace=True)



