# MuModelica Compiler Project
# Author: Steven Xu
# Modeling, Simulation and Design Lab (MSDL)
# School of Computer Science
# McGill University

class Edge:
    destination=None

    def getDestination(self):
        return self.destination

class FlowEdge(Edge):

    cap=1
    flow=0

    def __init__(self, destinationP, capP=1, flowP=0):
        #self.origin=originP
	self.destination=destinationP # Node
	self.cap=capP
	self.flow=flowP

    def getCap(self):
	return self.cap

    def getFlow(self):
	return self.flow

    def addFlow(self, value):
	self.flow=self.flow+value

    def reset(self):
	self.flow=0

    def __str__(self):
	return '(Flow: '+str(self.flow)+', '+ \
		'Destinaton: '+str(self.destination)+')'

#class DependencyEdge(Edge):
#    def __init__(self, destinationP):
#	self.destination=destinationP
