class NameException(Exception):
    """Base class for exception of illegal use of names"""
    pass

class NameNotDeclaredException(NameException):

    # name: String
    def __init__(self, name):
        self.name=name

    def __str__(self):
        return "\nName : " + str(self.name) + " is not declared!"

class UnencapsulatedElementException(NameException):

    # name: String
    def __init__(self, name):
        self.name=name

    def __str__(self):
        return "\nName : " + str(self.name) + \
		" must be an encapsulated element!"
