#ifndef INC_modelicaTokenTypes_hpp_
#define INC_modelicaTokenTypes_hpp_

/* $ANTLR 2.7.7 (2006-11-01): "modelica_lexer.g" -> "modelicaTokenTypes.hpp"$ */

#ifndef CUSTOM_API
# define CUSTOM_API
#endif

#ifdef __cplusplus
struct CUSTOM_API modelicaTokenTypes {
#endif
	enum {
		EOF_ = 1,
		ALGORITHM = 4,
		AND = 5,
		ANNOTATION = 6,
		BLOCK = 7,
		BOUNDARY = 8,
		CLASS = 9,
		CONNECT = 10,
		CONNECTOR = 11,
		CONSTANT = 12,
		DISCRETE = 13,
		EACH = 14,
		ELSE = 15,
		ELSEIF = 16,
		ELSEWHEN = 17,
		END = 18,
		ENUMERATION = 19,
		EQUATION = 20,
		ENCAPSULATED = 21,
		EXTENDS = 22,
		EXTERNAL = 23,
		FALSE = 24,
		FINAL = 25,
		FLOW = 26,
		FOR = 27,
		FUNCTION = 28,
		IF = 29,
		IMPORT = 30,
		IN = 31,
		INITIAL = 32,
		INNER = 33,
		INPUT = 34,
		LOOP = 35,
		MODEL = 36,
		NOT = 37,
		OUTER = 38,
		OR = 39,
		OUTPUT = 40,
		PACKAGE = 41,
		PARAMETER = 42,
		PARTIAL = 43,
		PROTECTED = 44,
		PUBLIC = 45,
		RECORD = 46,
		REDECLARE = 47,
		REPLACEABLE = 48,
		RESULTS = 49,
		THEN = 50,
		TRUE = 51,
		TYPE = 52,
		UNSIGNED_REAL = 53,
		WHEN = 54,
		WHILE = 55,
		WITHIN = 56,
		LPAR = 57,
		RPAR = 58,
		LBRACK = 59,
		RBRACK = 60,
		LBRACE = 61,
		RBRACE = 62,
		EQUALS = 63,
		ASSIGN = 64,
		PLUS = 65,
		MINUS = 66,
		STAR = 67,
		SLASH = 68,
		DOT = 69,
		COMMA = 70,
		LESS = 71,
		LESSEQ = 72,
		GREATER = 73,
		GREATEREQ = 74,
		EQEQ = 75,
		LESSGT = 76,
		COLON = 77,
		SEMICOLON = 78,
		POWER = 79,
		WS = 80,
		ML_COMMENT = 81,
		ML_COMMENT_CHAR = 82,
		SL_COMMENT = 83,
		IDENT = 84,
		NONDIGIT = 85,
		DIGIT = 86,
		EXPONENT = 87,
		UNSIGNED_INTEGER = 88,
		STRING = 89,
		SCHAR = 90,
		SESCAPE = 91,
		ESC = 92,
		NULL_TREE_LOOKAHEAD = 3
	};
#ifdef __cplusplus
};
#endif
#endif /*INC_modelicaTokenTypes_hpp_*/
