model SlidingMass "Sliding mass with inertia"
  extends Rigid;
  parameter Real m=1 "mass of the sliding mass";
  Real v "absolute velocity of component";
  Real a "absolute acceleration of component";
equation
  v = der(s);
  a = der(v);
  m*a = flange_a.f + flange_b.f;
end SlidingMass;
