model VsourceAC "Sin-wave voltage source"
  extends TwoPin;
  parameter Voltage VA = 110 "Amplitude";
  parameter Real f(unit="Hz") = 1  "Frequency";
  constant  Real pi=3.14;
equation
  v = VA*sin(2*f*pi*time);
end VsourceAC;
