from GraphRepr.Graph import Graph
from GraphRepr.Node import Node
from GraphManager.AGLGenerator.AGLGenerator import AGLGenerator
from GraphManager.AGLLoader.AGLLoader import AGLLoader

import time,os,sys


sep=os.sep

print ""
print "------------------------------------------"


start=time.time()

NUMNODE=100000
ID=0



testGraph=Graph("BIG")

for i in xrange(NUMNODE):
    testGraph.addElement(Node(str(ID)))
    ID+=1

start1=time.time()
print "Time needed to create a graph containing " + str(NUMNODE) + " nodes: " + str(start1-start)


mapping={}
mapping["BIG"]="C:"+sep+"mcgill"+sep+"623"+sep+"project"+sep+"graph"+sep+"Graphs"+sep+"SampleScripts"+sep+"big.agl"
gen=AGLGenerator(testGraph, mapping)
gen.genCode()

start2=time.time()
print "Time needed to generate code for " + str(NUMNODE) + " nodes: " + str(start2-start1)

loader=AGLLoader(mapping, "C:"+sep+"mcgill"+sep+"623"+sep+"project"+sep+"graph"+sep+"XMLTools"+sep+"catalog"+sep+"catalog.txt")

g=loader.load("BIG")

start3=time.time()
print "Time needed to load " + str(NUMNODE) + " nodes: " + str(start3-start2)

print "TOTAL TIME NEEDED: " + str(time.time()-start)
print "------------------------------------------"

