# Class to generate AGL from a graph instance
# By Marc Provost
# June 21th, V1.2

from GraphRepr.Graph import Graph
from GraphRepr.Node import Node

from GraphManager.AGLGenerator.AGLVisitors import AGLFirstPass
from GraphRepr.GraphUtils.Search import DFS

class AGLGenerator:

    def __init__(self, graph, fileMapping, indentSize="    "):

        #creating the python files
        newMap={}
        for key in fileMapping.keys():
            newMap[key]=open(fileMapping[key], 'w')

        self.__search=DFS(graph,
                          AGLFirstPass(newMap, indentSize))

    def genCode(self):
        self.__search.search()








