package P

  constant Real a = 0;

  type Voltage = Real(unit="V", start=a);

  type Current = Real(unit="A");

  class C
    Voltage v;
    Current i;
    Real r;
  equation
    v=i*a;
  end C;
end P;

model M
  type NewC = P.C(r=r);

  constant Real r=1.0;

  class SmallM
    extends P.C(r=r);
  end SmallM;

  P.C c;
end M;

